* IMPORTANT: this file probably needs to be modified for use with
* other compilers then StormC (for example check out byte parameter
* transfer)

                include glsmap_lib.i
                fpu
                far

INIT            macro
                link    a5,#0
                movem.l a4-a6,-(sp)
                add.l   #8,a5
                move.l  _glsmapBase,a6
                add.l   a6,a0
                move.l  a0,a4
                endm

EXIT            macro
                movem.l (sp)+,a4-a6
                unlk    a5
                rts
                endm

CALLFUNC        macro
                jsr     0(a4)
                endm

CALLFUNCQ       macro
                move.l  a6,-(sp)
                move.l  _glsmapBase,a6
                jsr     0(a6,a0.l)
                move.l  (sp)+,a6
                rts
                endm

GETM_LONG       macro
                movem.l (a5)+,\1
                endm

* GETM_WORD       macro
*                 movem.w (a5)+,\1
*                 endm

GETFLOAT        macro
                fmove.s (a5)+,\1
                endm

GETDOUBLE       macro
                fmove.d (a5)+,\1
                endm

GETLONG         macro
                move.l  (a5)+,\1
                endm

GETWORD         macro
                addq    #2,a5
                move.w  (a5)+,\1
                endm

GETBYTE         macro
                addq.l  #3,a5
                move.b  (a5)+,\1
                endm

GETTAGS         macro
                move.l  a5,\1
                endm

PUSH            macro
                movem.l \1,-(sp)
                endm

PUSHF           macro
                fmovem.x        \1,-(sp)
                endm

POP             macro
                movem.l (sp)+,\1
                endm

POPF            macro
                fmovem.x        (sp)+,\1
                endm

CALL            macro
_\1
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

CALLD           macro
_\1
                move.l  a6,-(sp)
                move.l  _glsmapBase,a6
                jsr     _LVO\1(a6)
                move.l  (sp)+,a6
                rts
                endm

CALLT           macro
_\1Tags
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

XDEFF           macro
                XDEF    \1__r
                endm

                XREF    _glsmapBase

                XDEF    _registerGLSMAP
                XDEF    _smapCreateSphereMap
                XDEF    _smapDestroySphereMap
                XDEF    _smapConfigureSphereMapMesh
                XDEF    _smapSetSphereMapTexObj
                XDEF    _smapSetViewTexObj
                XDEF    _smapSetViewTexObjs
                XDEF    _smapGetSphereMapTexObj
                XDEF    _smapGetViewTexObj
                XDEF    _smapGetViewTexObjs
                XDEF    _smapSetFlags
                XDEF    _smapGetFlags
                XDEF    _smapSetViewOrigin
                XDEF    _smapSetSphereMapOrigin
                XDEF    _smapGetViewOrigin
                XDEF    _smapGetSphereMapOrigin
                XDEF    _smapSetEye
                XDEF    _smapSetEyeVector
                XDEF    _smapSetUp
                XDEF    _smapSetUpVector
                XDEF    _smapSetObject
                XDEF    _smapSetObjectVector
                XDEF    _smapGetEye
                XDEF    _smapGetEyeVector
                XDEF    _smapGetUp
                XDEF    _smapGetUpVector
                XDEF    _smapGetObject
                XDEF    _smapGetObjectVector
                XDEF    _smapSetNearFar
                XDEF    _smapGetNearFar
                XDEF    _smapSetSphereMapTexDim
                XDEF    _smapSetViewTexDim
                XDEF    _smapGetSphereMapTexDim
                XDEF    _smapGetViewTexDim
                XDEF    _smapSetContextData
                XDEF    _smapGetContextData
                XDEF    _smapSetPositionLightsFunc
                XDEF    _smapSetDrawViewFunc
                XDEF    _smapGetPositionLightsFunc
                XDEF    _smapGetDrawViewFunc
                XDEF    _smapGenViewTex
                XDEF    _smapGenViewTexs
                XDEF    _smapGenSphereMapFromViewTexs
                XDEF    _smapGenSphereMap
                XDEF    _smapGenSphereMapWithOneViewTex
                XDEF    _smapRvecToSt
                XDEF    _smapStToRvec

                section "glsmapStubs",code

                CALLD   registerGLSMAP
                CALL    smapCreateSphereMap,a0
                CALL    smapDestroySphereMap,a0
                CALL    smapConfigureSphereMapMesh,a0_d0_d2
                CALL    smapSetSphereMapTexObj,a0_d0
                CALL    smapSetViewTexObj,a0_d0
                CALL    smapSetViewTexObjs,a0_a1
                CALL    smapGetSphereMapTexObj,a0_a1
                CALL    smapGetViewTexObj,a0_a1
                CALL    smapGetViewTexObjs,a0_a1
                CALL    smapSetFlags,a0_d0
                CALL    smapGetFlags,a0_a1
                CALL    smapSetViewOrigin,a0_d0_d1
                CALL    smapSetSphereMapOrigin,a0_d0_d1
                CALL    smapGetViewOrigin,a0_a2
                CALL    smapGetSphereMapOrigin,a0_a2
                CALL    smapSetEye,a0_fp0_fp2
                CALL    smapSetEyeVector,a0_a1
                CALL    smapSetUp,a0_fp0_fp2
                CALL    smapSetUpVector,a0_a1
                CALL    smapSetObject,a0_fp0_fp2
                CALL    smapSetObjectVector,a0_a1
                CALL    smapGetEye,a0_a3
                CALL    smapGetEyeVector,a0_a1
                CALL    smapGetUp,a0_a3
                CALL    smapGetUpVector,a0_a1
                CALL    smapGetObject,a0_a3
                CALL    smapGetObjectVector,a0_a1
                CALL    smapSetNearFar,a0_fp0_fp1
                CALL    smapGetNearFar,a0_a2
                CALL    smapSetSphereMapTexDim,a0_d0
                CALL    smapSetViewTexDim,a0_d0
                CALL    smapGetSphereMapTexDim,a0_a1
                CALL    smapGetViewTexDim,a0_a1
                CALL    smapSetContextData,a0_a1
                CALL    smapGetContextData,a0_a1
                CALL    smapSetPositionLightsFunc,a0_a1
                CALL    smapSetDrawViewFunc,a0_a1
                CALL    smapGetPositionLightsFunc,a0_a1
                CALL    smapGetDrawViewFunc,a0_a1
                CALL    smapGenViewTex,a0_d0
                CALL    smapGenViewTexs,a0
                CALL    smapGenSphereMapFromViewTexs,a0
                CALL    smapGenSphereMap,a0
                CALL    smapGenSphereMapWithOneViewTex,a0
                CALL    smapRvecToSt,a0_a1
                CALL    smapStToRvec,a0_a1

_Func_a0
                INIT
                GETLONG         a0
                CALLFUNC
                EXIT

_Func_a0_d0
                INIT
                GETLONG         a0
                GETLONG         d0
                CALLFUNC
                EXIT

_Func_a0_a1
                INIT
                GETLONG         a0
                GETLONG         a1
                CALLFUNC
                EXIT

_Func_a0_d0_d1
                INIT
                GETLONG         a0
                GETLONG         d0
                GETLONG         d1
                CALLFUNC
                EXIT

_Func_a0_d0_d2
                INIT
                PUSH            d2
                GETLONG         a0
                GETM_LONG       d0-d2
                CALLFUNC
                POP             d2
                EXIT

_Func_a0_a2
                INIT
                PUSH            a2
                GETM_LONG       a0-a2
                CALLFUNC
                POP             a2
                EXIT

_Func_a0_a3
                INIT
                PUSH            a2/a3
                GETM_LONG       a0-a3
                CALLFUNC
                POP             a2/a3
                EXIT

_Func_a0_fp0_fp1
                INIT
                GETLONG         a0
                GETFLOAT        fp0
                GETFLOAT        fp1
                CALLFUNC
                EXIT

_Func_a0_fp0_fp2
                INIT
                PUSHF           fp2
                GETLONG         a0
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETFLOAT        fp2
                CALLFUNC
                POPF            fp2
                EXIT
