#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <clib/exec_protos.h>
#include <pragmas/exec_pragmas.h>
#include "glesm.h"

extern struct Library* glBase;
extern struct Library* gluBase;
struct Library* gleBase = NULL;

struct glereg gle_reg;

INIT_9_OpenLibs(void)
{
        if (!(gleBase = OpenLibrary("agle.library",0)))
        {
                printf("Failed to open 'agle.library'\n");
                exit(0);
        }
        CacheClearU();
        gle_reg.size = (int)sizeof(struct glereg);
        gle_reg.func_exit = exit;
        gle_reg.glbase = glBase;
        gle_reg.glubase = gluBase;
        registerGLE(&gle_reg);
}

EXIT_9_OpenLibs(void)
{
        if (gleBase)
                CloseLibrary(gleBase);
}

