#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <clib/exec_protos.h>
#include "glesm.h"

void* getR2();

extern struct Library* glppcBase;
extern struct Library* gluppcBase;
struct Library* gleppcBase = NULL;

struct glereg gle_reg;

INIT_9_OpenLibs(void)
{
	if (!(gleppcBase = OpenLibrary("agleppc.library",0)))
	{
		printf("Failed to open 'agleppc.library'\n");
		exit(0);
	}
	gle_reg.size = (int)sizeof(struct glereg);
	gle_reg.func_exit = exit;
	gle_reg.glbase = glppcBase;
	gle_reg.glubase = gluppcBase;
	gle_reg.base = (void *)getR2();
	registerGLE(&gle_reg);
}

EXIT_9_OpenLibs(void)
{
	if (gleppcBase)
		CloseLibrary(gleppcBase);
}
