#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <clib/exec_protos.h>
#include "glsmapsm.h"

void* getR2();

extern struct Library* glppcBase;
extern struct Library* gluppcBase;
struct Library* glsmapppcBase = NULL;

struct glsmapreg glsmap_reg;

INIT_9_OpenLibs(void)
{
        if (!(glsmapppcBase = OpenLibrary("aglsmapppc.library",0)))
        {
                printf("Failed to open 'aglsmapppc.library'\n");
                exit(0);
        }
        glsmap_reg.size = (int)sizeof(struct glsmapreg);
        glsmap_reg.func_exit = exit;
        glsmap_reg.glbase = glppcBase;
        glsmap_reg.glubase = gluppcBase;
        glsmap_reg.base = (void *)getR2();
        registerGLSMAP(&glsmap_reg);
}

EXIT_9_OpenLibs(void)
{
        if (glsmapppcBase)
                CloseLibrary(glsmapppcBase);
}
