#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <proto/exec.h>
#include "glsmapinit.h"

extern struct Library *GLBASE;
extern struct Library *GLUBASE;
struct Library *GLSMAPBASE = NULL;


void _INIT_9_glsmap()
{
  char *glsmapname = GLSMAPNAME;

  if (!(GLSMAPBASE = OpenLibrary(glsmapname,0))) {
    fprintf(stderr,"Failed to open '%s'\n",glsmapname);
    exit(EXIT_FAILURE);
  }
#ifndef __PPC__
  CacheClearU();
#endif
  glsmap_reg.size = (int)sizeof(struct glsmapreg);
  glsmap_reg.func_exit = exit;
  glsmap_reg.glbase = GLBASE;
  glsmap_reg.glubase = GLUBASE;
#ifdef __PPC__
  glsmap_reg.base = getR2();
#endif
  registerGLSMAP(&glsmap_reg);
}


void _EXIT_9_glsmap()
{
  if (GLSMAPBASE)
    CloseLibrary(GLSMAPBASE);
}
