/*
** glsmapinit.h for Amiga/M68k and WarpOS/PPC
*/

#ifndef __PPC__
#define GLBASE glBase
#define GLUBASE gluBase
#define GLSMAPBASE glsmapBase
#define GLSMAPNAME "aglsmap.library"
#else
#define GLBASE glppcBase
#define GLUBASE gluppcBase
#define GLSMAPBASE glsmapppcBase
#define GLSMAPNAME "aglsmapppc.library"
extern void *getR2();
#endif

static struct glsmapreg
{
  int size;
  void (*func_exit)();
  struct Library *glbase;
  struct Library *glubase;
#ifdef __PPC__
  void *base;
#endif
} glsmap_reg;


#ifndef __PPC__
void __registerGLSMAP(__reg("a0")struct glsmapreg *,__reg("a6") void *) =
        "\tjsr\t-30(a6)";
#define registerGLSMAP(x) __registerGLSMAP(x,glsmapBase)

#else
void __registerGLSMAP(struct glsmapreg *) =
        "\tstw\tr2,20(r1)\n"
        "\tlwz\tr2,_glsmapppcBase(r2)\n"
        "\tlwz\tr0,-28(r2)\n"
        "\tmtlr\tr0\n"
        "\tblrl\n"
        "\tlwz\tr2,20(r1)";
#define registerGLSMAP(x) __registerGLSMAP(x)
#endif
