#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <clib/exec_protos.h>
#include <pragmas/exec_pragmas.h>
#include "glsmapsm.h"

extern struct Library* glBase;
extern struct Library* gluBase;
struct Library* glsmapBase = NULL;

struct glsmapreg glsmap_reg;

INIT_9_OpenLibs(void)
{
        if (!(glsmapBase = OpenLibrary("aglsmap.library",0)))
        {
                printf("Failed to open 'aglsmap.library'\n");
                exit(0);
        }
        CacheClearU();
        glsmap_reg.size = (int)sizeof(struct glsmapreg);
        glsmap_reg.func_exit = exit;
        glsmap_reg.glbase = glBase;
        glsmap_reg.glubase = gluBase;
        registerGLSMAP(&glsmap_reg);
}

EXIT_9_OpenLibs(void)
{
        if (glsmapBase)
                CloseLibrary(glsmapBase);
}

