* IMPORTANT: this file probably needs to be modified for use with
* other compilers then StormC (for example check out byte parameter
* transfer)

                include glu_lib.i
                fpu
                far

INIT            macro
                movem.l a4-a6,-(sp)
                lea     16(sp),a5
                move.l  _gluBase,a6
                add.l   a6,a0
                move.l  a0,a4
                endm

EXIT            macro
                movem.l (sp)+,a4-a6
                rts
                endm

CALLFUNC        macro
                jsr     0(a4)
                endm

CALLFUNCQ       macro
                move.l  a6,-(sp)
                move.l  _gluBase,a6
                jsr     0(a6,a0.l)
                move.l  (sp)+,a6
                rts
                endm

GETM_LONG       macro
                movem.l (a5)+,\1
                endm

GETM_WORD       macro
                movem.w (a5)+,\1
                endm

GETFLOAT        macro
                fmove.s (a5)+,\1
                endm

GETDOUBLE       macro
                fmove.d (a5)+,\1
                endm

GETDOUBLE_DN    macro
                move.l  (a5)+,\1
                move.l  (a5)+,\2
                endm

GETLONG         macro
                move.l  (a5)+,\1
                endm

GETWORD         macro
                move.w  (a5)+,\1
                endm

GETBYTE         macro           ; might not work with other compilers!
                move.b  (a5)+,\1
                addq.l  #1,a5
                endm

GETTAGS         macro
                move.l  a5,\1
                endm

PUSH            macro
                movem.l \1,-(sp)
                endm

PUSHF           macro
                fmovem.x        \1,-(sp)
                endm

POP             macro
                movem.l (sp)+,\1
                endm

POPF            macro
                fmovem.x        (sp)+,\1
                endm

CALL            macro
_\1
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

CALLD           macro
_\1
                move.l  a6,-(sp)
                move.l  _gluBase,a6
                jsr     _LVO\1(a6)
                move.l  (sp)+,a6
                rts
                endm

                XREF    _gluBase

                XDEF    _registerGLU
                XDEF    _gluLookAt
                XDEF    _gluOrtho2D
                XDEF    _gluPerspective
                XDEF    _gluPickMatrix
                XDEF    _gluProject
                XDEF    _gluUnProject
                XDEF    _gluErrorString
                XDEF    _gluScaleImage
                XDEF    _gluBuild1DMipmaps
                XDEF    _gluBuild2DMipmaps
                XDEF    _gluNewQuadric
                XDEF    _gluDeleteQuadric
                XDEF    _gluQuadricDrawStyle
                XDEF    _gluQuadricOrientation
                XDEF    _gluQuadricNormals
                XDEF    _gluQuadricTexture
                XDEF    _gluQuadricCallback
                XDEF    _gluCylinder
                XDEF    _gluSphere
                XDEF    _gluDisk
                XDEF    _gluPartialDisk
                XDEF    _gluNewNurbsRenderer
                XDEF    _gluDeleteNurbsRenderer
                XDEF    _gluLoadSamplingMatrices
                XDEF    _gluNurbsProperty
                XDEF    _gluGetNurbsProperty
                XDEF    _gluBeginCurve
                XDEF    _gluEndCurve
                XDEF    _gluNurbsCurve
                XDEF    _gluBeginSurface
                XDEF    _gluEndSurface
                XDEF    _gluNurbsSurface
                XDEF    _gluBeginTrim
                XDEF    _gluEndTrim
                XDEF    _gluPwlCurve
                XDEF    _gluNurbsCallback
                XDEF    _gluNewTess
                XDEF    _gluTessCallback
                XDEF    _gluDeleteTess
                XDEF    _gluBeginPolygon
                XDEF    _gluEndPolygon
                XDEF    _gluNextContour
                XDEF    _gluTessVertex
                XDEF    _gluGetString

                section "gluStubs",code

                CALLD   registerGLU
                CALL    gluLookAt,dfp0_dfp8
                CALL    gluOrtho2D,dfp0_dfp3
                CALL    gluPerspective,dfp0_dfp3
                CALL    gluPickMatrix,dfp0_dfp3_a0
                CALL    gluProject,dfp0_dfp2_a0_a3_d0_d1
                CALL    gluUnProject,dfp0_dfp2_a0_a3_d0_d1
                CALL    gluErrorString,d0
                CALL    gluScaleImage,d0_d3_a0_d4_d6_a1
                CALL    gluBuild1DMipmaps,d0_d4_a0
                CALL    gluBuild2DMipmaps,d0_d5_a0
                CALL    gluNewQuadric,void
                CALL    gluDeleteQuadric,a0
                CALL    gluQuadricDrawStyle,a0_d0
                CALL    gluQuadricOrientation,a0_d0
                CALL    gluQuadricNormals,a0_d0
                CALL    gluQuadricTexture,a0_bd0
                CALL    gluQuadricCallback,a0_d0_a1
                CALL    gluCylinder,a0_dfp0_dfp2_d0_d1
                CALL    gluSphere,a0_dfp0_d0_d1
                CALL    gluDisk,a0_dfp0_dfp1_d0_d1
                CALL    gluPartialDisk,a0_dfp0_dfp1_d0_d1_dfp2_dfp3
                CALL    gluNewNurbsRenderer,void
                CALL    gluDeleteNurbsRenderer,a0
                CALL    gluLoadSamplingMatrices,a0_a3
                CALL    gluNurbsProperty,a0_d0_fp0
                CALL    gluGetNurbsProperty,a0_d0_a1
                CALL    gluBeginCurve,a0
                CALL    gluEndCurve,a0
                CALL    gluNurbsCurve,a0_d0_a1_d1_a2_d2_d3
                CALL    gluBeginSurface,a0
                CALL    gluEndSurface,a0
                CALL    gluNurbsSurface,a0_d0_a1_d1_a2_d2_d3_a3_d4_d6
                CALL    gluBeginTrim,a0
                CALL    gluEndTrim,a0
                CALL    gluPwlCurve,a0_d0_a1_d1_d2
                CALL    gluNurbsCallback,a0_d0_a1
                CALL    gluNewTess,void
                CALL    gluTessCallback,a0_d0_a1
                CALL    gluDeleteTess,a0
                CALL    gluBeginPolygon,a0
                CALL    gluEndPolygon,a0
                CALL    gluNextContour,a0_d0
                CALL    gluTessVertex,a0_a2
                CALL    gluGetString,d0


_Func_void
                CALLFUNCQ

_Func_d0
                INIT
                GETLONG         d0
                CALLFUNC
                EXIT

_Func_a0
                INIT
                GETLONG         a0
                CALLFUNC
                EXIT

_Func_a0_d0
                INIT
                GETLONG         a0
                GETLONG         d0
                CALLFUNC
                EXIT

_Func_a0_bd0
                INIT
                GETLONG         a0
                GETBYTE         d0
                CALLFUNC
                EXIT

_Func_a0_a2
                INIT
                PUSH            a2
                GETM_LONG       a0-a2
                CALLFUNC
                POP             a2
                EXIT

_Func_a0_a3
                INIT
                PUSH            a2/a3
                GETM_LONG       a0-a3
                CALLFUNC
                POP             a2/a3
                EXIT

_Func_a0_d0_a1
                INIT
                GETLONG         a0
                GETLONG         d0
                GETLONG         a1
                CALLFUNC
                EXIT

_Func_d0_d4_a0
                INIT
                PUSH            d2-d4
                GETM_LONG       d0-d4/a0
                CALLFUNC
                POP             d2-d4
                EXIT

_Func_d0_d5_a0
                INIT
                PUSH            d2-d5
                GETM_LONG       d0-d5/a0
                CALLFUNC
                POP             d2-d5
                EXIT

_Func_a0_dfp0_d0_d1
                INIT
                GETLONG         a0
                GETDOUBLE       fp0
                GETLONG         d0
                GETLONG         d1
                CALLFUNC
                EXIT

_Func_a0_d0_fp0
                INIT
                GETLONG         a0
                GETLONG         d0
                GETFLOAT        fp0
                CALLFUNC
                EXIT

_Func_a0_dfp0_dfp1_d0_d1
                INIT
                GETLONG         a0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETLONG         d0
                GETLONG         d1
                CALLFUNC
                EXIT

_Func_dfp0_dfp8
                INIT
                PUSHF           fp2-fp7
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                GETDOUBLE       fp4
                GETDOUBLE       fp5
                GETDOUBLE       fp6
                GETDOUBLE       fp7
                GETDOUBLE_DN    d0,d1
                CALLFUNC
                POPF            fp2-fp7
                EXIT

_Func_dfp0_dfp3
                INIT
                PUSHF           fp2/fp3
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_dfp0_dfp3_a0
                INIT
                PUSHF           fp2/fp3
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                GETLONG         a0
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_a0_dfp0_dfp2_d0_d1
                INIT
                PUSHF           fp2
                GETLONG         a0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETLONG         d0
                GETLONG         d1
                CALLFUNC
                POPF            fp2
                EXIT

_Func_a0_d0_a1_d1_d2
                INIT
                PUSH            d2
                GETLONG         a0
                GETLONG         d0
                GETLONG         a1
                GETLONG         d1
                GETLONG         d2
                CALLFUNC
                POP             d2
                EXIT

_Func_a0_d0_a1_d1_a2_d2_d3
                INIT
                PUSH            d2/d3/a2
                GETLONG         a0
                GETLONG         d0
                GETLONG         a1
                GETLONG         d1
                GETLONG         a2
                GETLONG         d2
                GETLONG         d3
                CALLFUNC
                POP             d2/d3/a2
                EXIT

_Func_a0_dfp0_dfp1_d0_d1_dfp2_dfp3
                INIT
                PUSHF           fp2/fp3
                GETLONG         a0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETLONG         d0
                GETLONG         d1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_dfp0_dfp2_a0_a3_d0_d1
                INIT
                PUSH            a2/a3
                PUSHF           fp2
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETM_LONG       a0-a3
                GETLONG         d0
                GETLONG         d1
                CALLFUNC
                POPF            fp2
                POP             a2/a3
                EXIT

_Func_d0_d3_a0_d4_d6_a1
                INIT
                PUSH            d2-d6
                GETM_LONG       d0-d3
                GETLONG         a0
                GETM_LONG       d4-d6
                GETLONG         a1
                CALLFUNC
                POP             d2-d6
                EXIT

_Func_a0_d0_a1_d1_a2_d2_d3_a3_d4_d6
                INIT
                PUSH            d2-d6/a2/a3
                GETLONG         a0
                GETLONG         d0
                GETLONG         a1
                GETLONG         d1
                GETLONG         a2
                GETLONG         d2
                GETLONG         d3
                GETLONG         a3
                GETM_LONG       d4-d6
                CALLFUNC
                POP             d2-d6/a2/a3
                EXIT
