#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <proto/exec.h>
#include "gleinit.h"

extern struct Library *GLBASE;
extern struct Library *GLUBASE;
struct Library *GLEBASE = NULL;


void _INIT_9_GLE()
{
  char *glename = GLENAME;

  if (!(GLEBASE = OpenLibrary(glename,0))) {
    fprintf(stderr,"Failed to open '%s'\n",glename);
    exit(EXIT_FAILURE);
  }
#ifndef __PPC__
  CacheClearU();
#endif
  gle_reg.size = (int)sizeof(struct glereg);
  gle_reg.func_exit = exit;
  gle_reg.glbase = GLBASE;
  gle_reg.glubase = GLUBASE;
#ifdef __PPC__
  gle_reg.base = getR2();
#endif
  registerGLE(&gle_reg);
}


void _EXIT_9_GLE()
{
  if (GLEBASE)
    CloseLibrary(GLEBASE);
}
