/*
** gleinit.h for Amiga/M68k and WarpOS/PPC
*/

#ifndef __PPC__
#define GLBASE glBase
#define GLUBASE gluBase
#define GLEBASE gleBase
#define GLENAME "agle.library"
#else
#define GLBASE glppcBase
#define GLUBASE gluppcBase
#define GLEBASE gleppcBase
#define GLENAME "agleppc.library"
extern void *getR2();
#endif

static struct glereg
{
  int size;
  void (*func_exit)();
  struct Library *glbase;
  struct Library *glubase;
#ifdef __PPC__
  void *base;
#endif
} gle_reg;


#ifndef __PPC__
void __registerGLE(__reg("a0")struct glereg *,__reg("a6") void *) =
        "\tjsr\t-30(a6)";
#define registerGLE(x) __registerGLE(x,gleBase)

#else
void __registerGLE(struct glereg *) =
        "\tstw\tr2,20(r1)\n"
        "\tlwz\tr2,_gleppcBase(r2)\n"
        "\tlwz\tr0,-28(r2)\n"
        "\tmtlr\tr0\n"
        "\tblrl\n"
        "\tlwz\tr2,20(r1)";
#define registerGLE(x) __registerGLE(x)
#endif
