#include <GL/gl.h>

extern void _beginPPC( GLenum mode );
extern void _edgeFlagPPC( GLboolean flag );
extern void _vertexPPC( GLvoid *v );
extern void _endPPC( void );
extern void _errorPPC( GLenum err );
extern void _error_callbackPPC( GLenum err );
extern void _ErrorFuncPPC( GLenum err );

void* currentCallback = NULL;

void beginPPC( GLenum mode )
{
	if (currentCallback)
		_beginPPC(mode);
}

void edgeFlagPPC( GLboolean flag )
{
	if (currentCallback)
		_edgeFlagPPC(flag);
}

void vertexPPC( GLvoid *v )
{
	if (currentCallback)
		_vertexPPC(v);
}

void endPPC( void )
{
	if (currentCallback)
		_endPPC();
}

void errorPPC( GLenum err )
{
	if (currentCallback)
		_errorPPC(err);
}

void error_callbackPPC( GLenum err )
{
	if (currentCallback)
		_error_callbackPPC(err);
}

void ErrorFuncPPC( GLenum err )
{
	if (currentCallback)
		_ErrorFuncPPC(err);
}

