#include <exec/types.h>
#include <clib/intuition_protos.h>
#include <clib/asl_protos.h>
#include <clib/cybergraphics_protos.h>

struct Window *OpenWindowTags( struct NewWindow *newWindow,
        unsigned long tag1Type, ... )
{
        return OpenWindowTagList(newWindow,(struct TagItem *)&tag1Type);
}

struct Screen *OpenScreenTags( struct NewScreen *newScreen,
        unsigned long tag1Type, ... )
{
        return OpenScreenTagList(newScreen,(struct TagItem *)&tag1Type);
}

APTR AllocAslRequestTags( unsigned long reqType, Tag Tag1, ... )
{
        return AllocAslRequest(reqType,(struct TagItem *)&Tag1);
}

BOOL AslRequestTags( APTR requester, Tag Tag1, ... )
{
        return AslRequest(requester,(struct TagItem *)&Tag1);
}

ULONG        CModeRequestTags(APTR a, Tag b, ...)
{
        return CModeRequestTagList(a,(struct TagItem *)&b);
}

