
; Storm C Compiler
; Work2:Mesa3/Mesa-3.0/src/apiext.c
	mc68030
	mc68881
	XREF	_glCopyTexSubImage3D
	XREF	_glTexSubImage3D
	XREF	_glTexImage3D
	XREF	_glIsTexture
	XREF	_glAreTexturesResident
	XREF	_glPrioritizeTextures
	XREF	_glBindTexture
	XREF	_glDeleteTextures
	XREF	_glGenTextures
	XREF	_getenv
	XREF	_fprintf
	XREF	_std__in
	XREF	_std__out
	XREF	_std__err
	XREF	_CC

	SECTION "_glBlendEquationEXT:0",CODE


;void APIENTRY glBlendEquationEXT( GLenum mode )
	XDEF	_glBlendEquationEXT
_glBlendEquationEXT
	move.l	4(a7),d0
L47
;   
	tst.l	_CC(a6)
	bne.b	L51
L48
;   
	move.l	#L45,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L50
L49
;   
	move.l	#L46,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L50
	rts
L51
;   (*CC->API.BlendEquation)(CC, mode);
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$24(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L45
	dc.b	'MESA_DEBUG',0
L46
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glBlendColorEXT:0",CODE

	rts

;void APIENTRY glBlendColorEXT( GLclampf red, GLclampf green,
	XDEF	_glBlendColorEXT
_glBlendColorEXT
	fmovem.x fp2/fp3,-(a7)
	fmove.s	$1C(a7),fp0
	fmove.s	$20(a7),fp1
	fmove.s	$24(a7),fp2
	fmove.s	$28(a7),fp3
L54
;   
	tst.l	_CC(a6)
	bne.b	L58
L55
;   
	move.l	#L52,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L57
L56
;   
	move.l	#L53,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L57
	fmovem.x (a7)+,fp2/fp3
	rts
L58
;   (*CC->API.BlendColor)(CC, red, green, blue, alpha);
	fmove.s	fp3,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$20(a1),a0
	jsr	(a0)
	add.w	#$14,a7
	fmovem.x (a7)+,fp2/fp3
	rts

L52
	dc.b	'MESA_DEBUG',0
L53
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glVertexPointerEXT:0",CODE


;void APIENTRY glVertexPointerEXT( GLint size, GLenum type, GLsizei s
	XDEF	_glVertexPointerEXT
_glVertexPointerEXT
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d2
	move.l	$1C(a7),a0
L61
;   
	tst.l	_CC(a6)
	bne.b	L65
L62
;   
	move.l	#L59,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L64
L63
;   
	move.l	#L60,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L64
	movem.l	(a7)+,d2/d3
	rts
L65
;   (*CC->API.VertexPointer)(CC, size, type, stride, ptr);
	move.l	a0,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2D4(a1),a0
	jsr	(a0)
	add.w	#$14,a7
;   (void) count;
	movem.l	(a7)+,d2/d3
	rts

L59
	dc.b	'MESA_DEBUG',0
L60
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glNormalPointerEXT:0",CODE


;void APIENTRY glNormalPointerEXT( GLenum type, GLsizei stride, GLsiz
	XDEF	_glNormalPointerEXT
_glNormalPointerEXT
	move.l	d2,-(a7)
	movem.l	$8(a7),d0/d1
	move.l	$14(a7),a0
L68
;   
	tst.l	_CC(a6)
	bne.b	L72
L69
;   
	move.l	#L66,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L71
L70
;   
	move.l	#L67,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L71
	move.l	(a7)+,d2
	rts
L72
;   (*CC->API.NormalPointer)(CC, type, stride, ptr);
	move.l	a0,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$20C(a1),a0
	jsr	(a0)
	add.w	#$10,a7
;   (void) count;
	move.l	(a7)+,d2
	rts

L66
	dc.b	'MESA_DEBUG',0
L67
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glColorPointerEXT:0",CODE


;void APIENTRY glColorPointerEXT( GLint size, GLenum type, GLsizei st
	XDEF	_glColorPointerEXT
_glColorPointerEXT
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d2
	move.l	$1C(a7),a0
L75
;   
	tst.l	_CC(a6)
	bne.b	L79
L76
;   
	move.l	#L73,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L78
L77
;   
	move.l	#L74,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L78
	movem.l	(a7)+,d2/d3
	rts
L79
;   (*CC->API.ColorPointer)(CC, size, type, stride, ptr);
	move.l	a0,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$70(a1),a0
	jsr	(a0)
	add.w	#$14,a7
;   (void) count;
	movem.l	(a7)+,d2/d3
	rts

L73
	dc.b	'MESA_DEBUG',0
L74
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glIndexPointerEXT:0",CODE


;void APIENTRY glIndexPointerEXT( GLenum type, GLsizei stride,
	XDEF	_glIndexPointerEXT
_glIndexPointerEXT
	move.l	d2,-(a7)
	movem.l	$8(a7),d0/d1
	move.l	$14(a7),a0
L82
;   
	tst.l	_CC(a6)
	bne.b	L86
L83
;   
	move.l	#L80,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L85
L84
;   
	move.l	#L81,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L85
	move.l	(a7)+,d2
	rts
L86
;   (*CC->API.IndexPointer)(CC, type, stride, ptr);
	move.l	a0,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$1A8(a1),a0
	jsr	(a0)
	add.w	#$10,a7
;   (void) count;
	move.l	(a7)+,d2
	rts

L80
	dc.b	'MESA_DEBUG',0
L81
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glTexCoordPointerEXT:0",CODE


;void APIENTRY glTexCoordPointerEXT( GLint size, GLenum type, GLsizei
	XDEF	_glTexCoordPointerEXT
_glTexCoordPointerEXT
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d2
	move.l	$1C(a7),a0
L89
;   
	tst.l	_CC(a6)
	bne.b	L93
L90
;   
	move.l	#L87,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L92
L91
;   
	move.l	#L88,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L92
	movem.l	(a7)+,d2/d3
	rts
L93
;   (*CC->API.TexCoordPointer)(CC, size, type, stride, ptr);
	move.l	a0,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$298(a1),a0
	jsr	(a0)
	add.w	#$14,a7
;   (void) count;
	movem.l	(a7)+,d2/d3
	rts

L87
	dc.b	'MESA_DEBUG',0
L88
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glEdgeFlagPointerEXT:0",CODE


;void APIENTRY glEdgeFlagPointerEXT( GLsizei stride, GLsizei count,
	XDEF	_glEdgeFlagPointerEXT
_glEdgeFlagPointerEXT
	move.l	4(a7),d0
	move.l	$C(a7),a0
L96
;   
	tst.l	_CC(a6)
	bne.b	L100
L97
;   
	move.l	#L94,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L99
L98
;   
	move.l	#L95,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L99
	rts
L100
;   (*CC->API.EdgeFlagPointer)(CC, stride, ptr);
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$CC(a1),a0
	jsr	(a0)
	add.w	#$C,a7
;   (void) count;
	rts

L94
	dc.b	'MESA_DEBUG',0
L95
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glGetPointervEXT:0",CODE


;void APIENTRY glGetPointervEXT( GLenum pname, GLvoid **params )
	XDEF	_glGetPointervEXT
_glGetPointervEXT
	movem.l	4(a7),d0/a0
L103
;   
	tst.l	_CC(a6)
	bne.b	L107
L104
;   
	move.l	#L101,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L106
L105
;   
	move.l	#L102,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L106
	rts
L107
;   (*CC->API.GetPointerv)(CC, pname, params);
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$164(a1),a0
	jsr	(a0)
	add.w	#$C,a7
	rts

L101
	dc.b	'MESA_DEBUG',0
L102
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glArrayElementEXT:0",CODE


;void APIENTRY glArrayElementEXT( GLint i )
	XDEF	_glArrayElementEXT
_glArrayElementEXT
	move.l	4(a7),d0
L110
;   
	tst.l	_CC(a6)
	bne.b	L114
L111
;   
	move.l	#L108,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L113
L112
;   
	move.l	#L109,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L113
	rts
L114
;   (*CC->API.ArrayElement)(CC, i);
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$10(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L108
	dc.b	'MESA_DEBUG',0
L109
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glDrawArraysEXT:0",CODE


;void APIENTRY glDrawArraysEXT( GLenum mode, GLint first, GLsizei cou
	XDEF	_glDrawArraysEXT
_glDrawArraysEXT
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d2
L117
;   
	tst.l	_CC(a6)
	bne.b	L121
L118
;   
	move.l	#L115,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L120
L119
;   
	move.l	#L116,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L120
	movem.l	(a7)+,d2/d3
	rts
L121
;   (*CC->API.DrawArrays)(CC, mode, first, count);
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$B4(a1),a0
	jsr	(a0)
	add.w	#$10,a7
	movem.l	(a7)+,d2/d3
	rts

L115
	dc.b	'MESA_DEBUG',0
L116
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glAreTexturesResidentEXT:0",CODE


;GLboolean APIENTRY glAreTexturesResidentEXT( GLsizei n, const GLuint
	XDEF	_glAreTexturesResidentEXT
_glAreTexturesResidentEXT
	movem.l	4(a7),d0/a0/a1
L122
	move.l	a1,-(a7)
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	jsr	_glAreTexturesResident
	add.w	#$C,a7
	rts

	SECTION "_glBindTextureEXT:0",CODE


;void APIENTRY glBindTextureEXT( GLenum target, GLuint texture )
	XDEF	_glBindTextureEXT
_glBindTextureEXT
	movem.l	4(a7),d0/d1
L123
;   glBindTexture( target, texture );
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	jsr	_glBindTexture
	addq.w	#$8,a7
	rts

	SECTION "_glDeleteTexturesEXT:0",CODE


;void APIENTRY glDeleteTexturesEXT( GLsizei n, const GLuint *textures)
	XDEF	_glDeleteTexturesEXT
_glDeleteTexturesEXT
	movem.l	4(a7),d0/a0
L124
;   glDeleteTextures( n, textures );
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	jsr	_glDeleteTextures
	addq.w	#$8,a7
	rts

	SECTION "_glGenTexturesEXT:0",CODE


;void APIENTRY glGenTexturesEXT( GLsizei n, GLuint *textures )
	XDEF	_glGenTexturesEXT
_glGenTexturesEXT
	movem.l	4(a7),d0/a0
L125
;   glGenTextures( n, textures );
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	jsr	_glGenTextures
	addq.w	#$8,a7
	rts

	SECTION "_glIsTextureEXT:0",CODE


;GLboolean APIENTRY glIsTextureEXT( GLuint texture )
	XDEF	_glIsTextureEXT
_glIsTextureEXT
	move.l	4(a7),d0
L126
	move.l	d0,-(a7)
	jsr	_glIsTexture
	addq.w	#4,a7
	rts

	SECTION "_glPrioritizeTexturesEXT:0",CODE


;void APIENTRY glPrioritizeTexturesEXT( GLsizei n, const GLuint *text
	XDEF	_glPrioritizeTexturesEXT
_glPrioritizeTexturesEXT
	movem.l	4(a7),d0/a0/a1
L127
;   glPrioritizeTextures( n, textures, priorities );
	move.l	a1,-(a7)
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	jsr	_glPrioritizeTextures
	add.w	#$C,a7
	rts

	SECTION "_glCopyTexSubImage3DEXT:0",CODE


;void APIENTRY glCopyTexSubImage3DEXT( GLenum target, GLint level, GL
	XDEF	_glCopyTexSubImage3DEXT
_glCopyTexSubImage3DEXT
L129	EQU	0
	link	a5,#L129
	movem.l	d2-d7,-(a7)
	movem.l	$8(a5),d0-d7
L128
;void APIENTRY glWin
	move.l	$28(a5),-(a7)
	move.l	d7,-(a7)
	move.l	d6,-(a7)
	move.l	d5,-(a7)
	move.l	d4,-(a7)
	move.l	d3,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	jsr	_glCopyTexSubImage3D
	add.w	#$24,a7
	movem.l	(a7)+,d2-d7
	unlk	a5
	rts

	SECTION "_glTexImage3DEXT:0",CODE


;void APIENTRY glTexImage3DEXT( GLenum target, GLint level, GLenum in
	XDEF	_glTexImage3DEXT
_glTexImage3DEXT
L131	EQU	0
	link	a5,#L131
	movem.l	d2-d7,-(a7)
	movem.l	$8(a5),d0-d7
	move.l	$2C(a5),a0
L130
;   glTexImage3D(target, level, internalformat, width, height, dep
	move.l	a0,-(a7)
	move.l	$28(a5),-(a7)
	move.l	d7,-(a7)
	move.l	d6,-(a7)
	move.l	d5,-(a7)
	move.l	d4,-(a7)
	move.l	d3,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	jsr	_glTexImage3D
	add.w	#$28,a7
	movem.l	(a7)+,d2-d7
	unlk	a5
	rts

	SECTION "_glTexSubImage3DEXT:0",CODE


;void APIENTRY glTexSubImage3DEXT( GLenum target, GLint level, GLint 
	XDEF	_glTexSubImage3DEXT
_glTexSubImage3DEXT
L133	EQU	0
	link	a5,#L133
	movem.l	d2-d7,-(a7)
	movem.l	$8(a5),d0-d7
	move.l	$30(a5),a0
L132
;   glTexSubImage3D(target, level, xoffset, yoffset, zoffset,
	move.l	a0,-(a7)
	move.l	$2C(a5),-(a7)
	move.l	$28(a5),-(a7)
	move.l	d7,-(a7)
	move.l	d6,-(a7)
	move.l	d5,-(a7)
	move.l	d4,-(a7)
	move.l	d3,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	jsr	_glTexSubImage3D
	add.w	#$2C,a7
	movem.l	(a7)+,d2-d7
	unlk	a5
	rts

	SECTION "_glPointParameterfEXT:0",CODE


;void APIENTRY glPointParameterfEXT( GLenum pname, GLfloat param )
	XDEF	_glPointParameterfEXT
_glPointParameterfEXT
L141	EQU	-$C
	link	a5,#L141
	move.l	$8(a5),d0
	fmove.s	$C(a5),fp0
L136
;   
	tst.l	_CC(a6)
	bne.b	L140
L137
;   
	move.l	#L134,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L139
L138
;   
	move.l	#L135,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L139
	unlk	a5
	rts
L140
;   params[0] = param;
	fmove.s	fp0,-$C(a5)
;   params[1] = 0.0;
	lea	-$C(a5),a0
	clr.l	4(a0)
;   params[2] = 0.0;
	lea	-$C(a5),a0
	clr.l	$8(a0)
;   (*CC->API.PointParameterfvEXT)(CC, pname, params);
	pea	-$C(a5)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$228(a1),a0
	jsr	(a0)
	add.w	#$C,a7
	unlk	a5
	rts

L134
	dc.b	'MESA_DEBUG',0
L135
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glPointParameterfvEXT:0",CODE


;void APIENTRY glPointParameterfvEXT( GLenum pname, const GLfloat *pa
	XDEF	_glPointParameterfvEXT
_glPointParameterfvEXT
	movem.l	4(a7),d0/a0
L144
;   
	tst.l	_CC(a6)
	bne.b	L148
L145
;   
	move.l	#L142,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L147
L146
;   
	move.l	#L143,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L147
	rts
L148
;   (*CC->API.PointParameterfvEXT)(CC, pname, params);
	move.l	a0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$228(a1),a0
	jsr	(a0)
	add.w	#$C,a7
	rts

L142
	dc.b	'MESA_DEBUG',0
L143
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glWindowPos4fMESA:0",CODE


;void APIENTRY glWindowPos4fMESA( GLfloat x, GLfloat y, GLfloat z, GL
	XDEF	_glWindowPos4fMESA
_glWindowPos4fMESA
	fmovem.x fp2/fp3,-(a7)
	fmove.s	$1C(a7),fp0
	fmove.s	$20(a7),fp1
	fmove.s	$24(a7),fp2
	fmove.s	$28(a7),fp3
L151
;   
	tst.l	_CC(a6)
	bne.b	L155
L152
;   
	move.l	#L149,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L154
L153
;   
	move.l	#L150,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L154
	fmovem.x (a7)+,fp2/fp3
	rts
L155
;   (*CC->API.WindowPos4fMESA)( CC, x, y, z, w );
	fmove.s	fp3,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2DC(a1),a0
	jsr	(a0)
	add.w	#$14,a7
	fmovem.x (a7)+,fp2/fp3
	rts

L149
	dc.b	'MESA_DEBUG',0
L150
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glWindowPos2iMESA:0",CODE


;void APIENTRY glWindowPos2iMESA( GLint x, GLint y )
	XDEF	_glWindowPos2iMESA
_glWindowPos2iMESA
	movem.l	4(a7),d0/d1
L156
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, 0.0F, 1.0F );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2sMESA:0",CODE


;void APIENTRY glWindowPos2sMESA( GLshort x, GLshort y )
	XDEF	_glWindowPos2sMESA
_glWindowPos2sMESA
	move.w	6(a7),d0
	move.w	4(a7),d1
L157
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, 0.0F, 1.0F );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d1,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2fMESA:0",CODE


;void APIENTRY glWindowPos2fMESA( GLfloat x, GLfloat y )
	XDEF	_glWindowPos2fMESA
_glWindowPos2fMESA
	fmove.s	4(a7),fp0
	fmove.s	$8(a7),fp1
L158
;   glWindowPos4fMESA( x, y, 0.0F, 1.0F );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2dMESA:0",CODE


;void APIENTRY glWindowPos2dMESA( GLdouble x, GLdouble y )
	XDEF	_glWindowPos2dMESA
_glWindowPos2dMESA
	fmove.d	$C(a7),fp0
	fmove.d	4(a7),fp1
L159
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, 0.0F, 1.0F );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2ivMESA:0",CODE


;void APIENTRY glWindowPos2ivMESA( const GLint *p )
	XDEF	_glWindowPos2ivMESA
_glWindowPos2ivMESA
	move.l	4(a7),a1
L160
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1], 0.0F, 1.0F )
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.l	4(a1),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a1),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2svMESA:0",CODE


;void APIENTRY glWindowPos2svMESA( const GLshort *p )
	XDEF	_glWindowPos2svMESA
_glWindowPos2svMESA
	move.l	4(a7),a1
L161
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1], 0.0F, 1.0F )
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	move.w	2(a1),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a1),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2fvMESA:0",CODE


;void APIENTRY glWindowPos2fvMESA( const GLfloat *p )
	XDEF	_glWindowPos2fvMESA
_glWindowPos2fvMESA
	move.l	4(a7),a1
L162
;   glWindowPos4fMESA( p[0], p[1], 0.0F, 1.0F );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	move.l	4(a1),-(a7)
	move.l	(a1),-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos2dvMESA:0",CODE


;void APIENTRY glWindowPos2dvMESA( const GLdouble *p )
	XDEF	_glWindowPos2dvMESA
_glWindowPos2dvMESA
	move.l	4(a7),a1
L163
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1], 0.0F, 1.0F )
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.d	$8(a1),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a1),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos3iMESA:0",CODE


;void APIENTRY glWindowPos3iMESA( GLint x, GLint y, GLint z )
	XDEF	_glWindowPos3iMESA
_glWindowPos3iMESA
	move.l	d2,-(a7)
	movem.l	$8(a7),d0-d2
L164
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, (GLfloat) z, 1.0F
	move.l	#$3F800000,-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	move.l	(a7)+,d2
	rts

	SECTION "_glWindowPos3sMESA:0",CODE


;void APIENTRY glWindowPos3sMESA( GLshort x, GLshort y, GLshort z )
	XDEF	_glWindowPos3sMESA
_glWindowPos3sMESA
	move.l	d2,-(a7)
	move.w	$C(a7),d0
	move.w	$8(a7),d1
	move.w	$A(a7),d2
L165
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, (GLfloat) z, 1.0F
	move.l	#$3F800000,-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d1,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	move.l	(a7)+,d2
	rts

	SECTION "_glWindowPos3fMESA:0",CODE


;void APIENTRY glWindowPos3fMESA( GLfloat x, GLfloat y, GLfloat z )
	XDEF	_glWindowPos3fMESA
_glWindowPos3fMESA
	fmovem.x fp2,-(a7)
	fmove.s	$10(a7),fp0
	fmove.s	$14(a7),fp1
	fmove.s	$18(a7),fp2
L166
;   glWindowPos4fMESA( x, y, z, 1.0F );
	move.l	#$3F800000,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	fmovem.x (a7)+,fp2
	rts

	SECTION "_glWindowPos3dMESA:0",CODE


;void APIENTRY glWindowPos3dMESA( GLdouble x, GLdouble y, GLdouble z )
	XDEF	_glWindowPos3dMESA
_glWindowPos3dMESA
	fmovem.x fp2,-(a7)
	fmove.d	$20(a7),fp0
	fmove.d	$10(a7),fp1
	fmove.d	$18(a7),fp2
L167
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, (GLfloat) z, 1.0F
	move.l	#$3F800000,-(a7)
	fmove.s	fp0,-(a7)
	fmove.x	fp2,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	fmovem.x (a7)+,fp2
	rts

	SECTION "_glWindowPos3ivMESA:0",CODE


;void APIENTRY glWindowPos3ivMESA( const GLint *p )
	XDEF	_glWindowPos3ivMESA
_glWindowPos3ivMESA
	move.l	4(a7),a0
L168
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1], (GLfloat) p
	move.l	#$3F800000,-(a7)
	fmove.l	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	4(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos3svMESA:0",CODE


;void APIENTRY glWindowPos3svMESA( const GLshort *p )
	XDEF	_glWindowPos3svMESA
_glWindowPos3svMESA
	move.l	4(a7),a0
L169
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1], (GLfloat) p
	move.l	#$3F800000,-(a7)
	move.w	4(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	2(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos3fvMESA:0",CODE


;void APIENTRY glWindowPos3fvMESA( const GLfloat *p )
	XDEF	_glWindowPos3fvMESA
_glWindowPos3fvMESA
	move.l	4(a7),a0
L170
;   glWindowPos4fMESA( p[0], p[1], p[2], 1.0F );
	move.l	#$3F800000,-(a7)
	move.l	$8(a0),-(a7)
	move.l	4(a0),-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos3dvMESA:0",CODE


;void APIENTRY glWindowPos3dvMESA( const GLdouble *p )
	XDEF	_glWindowPos3dvMESA
_glWindowPos3dvMESA
	move.l	4(a7),a0
L171
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1], (GLfloat) p
	move.l	#$3F800000,-(a7)
	fmove.d	$10(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos4iMESA:0",CODE


;void APIENTRY glWindowPos4iMESA( GLint x, GLint y, GLint z, GLint w )
	XDEF	_glWindowPos4iMESA
_glWindowPos4iMESA
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d3
L172
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, (GLfloat) z, (GLf
	fmove.l	d3,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	movem.l	(a7)+,d2/d3
	rts

	SECTION "_glWindowPos4sMESA:0",CODE


;void APIENTRY glWindowPos4sMESA( GLshort x, GLshort y, GLshort z, GL
	XDEF	_glWindowPos4sMESA
_glWindowPos4sMESA
	movem.l	d2/d3,-(a7)
	move.w	$12(a7),d0
	move.w	$C(a7),d1
	move.w	$E(a7),d2
	move.w	$10(a7),d3
L173
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, (GLfloat) z, (GLf
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d3,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d1,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	movem.l	(a7)+,d2/d3
	rts

	SECTION "_glWindowPos4dMESA:0",CODE


;void APIENTRY glWindowPos4dMESA( GLdouble x, GLdouble y, GLdouble z,
	XDEF	_glWindowPos4dMESA
_glWindowPos4dMESA
	fmovem.x fp2/fp3,-(a7)
	fmove.d	$34(a7),fp0
	fmove.d	$1C(a7),fp1
	fmove.d	$24(a7),fp2
	fmove.d	$2C(a7),fp3
L174
;   glWindowPos4fMESA( (GLfloat) x, (GLfloat) y, (GLfloat) z, (GLf
	fmove.s	fp0,-(a7)
	fmove.x	fp3,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp2,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	fmovem.x (a7)+,fp2/fp3
	rts

	SECTION "_glWindowPos4ivMESA:0",CODE


;void APIENTRY glWindowPos4ivMESA( const GLint *p )
	XDEF	_glWindowPos4ivMESA
_glWindowPos4ivMESA
	move.l	4(a7),a0
L175
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1],
	fmove.l	$C(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	4(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos4svMESA:0",CODE


;void APIENTRY glWindowPos4svMESA( const GLshort *p )
	XDEF	_glWindowPos4svMESA
_glWindowPos4svMESA
	move.l	4(a7),a0
L176
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1],
	move.w	6(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	4(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	2(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos4fvMESA:0",CODE


;void APIENTRY glWindowPos4fvMESA( const GLfloat *p )
	XDEF	_glWindowPos4fvMESA
_glWindowPos4fvMESA
	move.l	4(a7),a0
L177
;   glWindowPos4fMESA( p[0], p[1], p[2], p[3] );
	move.l	$C(a0),-(a7)
	move.l	$8(a0),-(a7)
	move.l	4(a0),-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glWindowPos4dvMESA:0",CODE


;void APIENTRY glWindowPos4dvMESA( const GLdouble *p )
	XDEF	_glWindowPos4dvMESA
_glWindowPos4dvMESA
	move.l	4(a7),a0
L178
;   glWindowPos4fMESA( (GLfloat) p[0], (GLfloat) p[1],
	fmove.d	$18(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$10(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	jsr	_glWindowPos4fMESA
	add.w	#$10,a7
	rts

	SECTION "_glResizeBuffersMESA:0",CODE


;void APIENTRY glResizeBuffersMESA( void )
	XDEF	_glResizeBuffersMESA
_glResizeBuffersMESA
L181
;   
	tst.l	_CC(a6)
	bne.b	L185
L182
;   
	move.l	#L179,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L184
L183
;   
	move.l	#L180,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L184
	rts
L185
;   (*CC->API.ResizeBuffersMESA)( CC );
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E0(a1),a0
	jsr	(a0)
	addq.w	#4,a7
	rts

L179
	dc.b	'MESA_DEBUG',0
L180
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glMultiTexCoord1dSGIS:0",CODE


;void APIENTRY glMultiTexCoord1dSGIS(GLenum target, GLdouble s)
	XDEF	_glMultiTexCoord1dSGIS
_glMultiTexCoord1dSGIS
	move.l	4(a7),d0
	fmove.d	$8(a7),fp0
L186
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1dvSGIS:0",CODE


;void APIENTRY glMultiTexCoord1dvSGIS(GLenum target, const GLdouble *
	XDEF	_glMultiTexCoord1dvSGIS
_glMultiTexCoord1dvSGIS
	movem.l	4(a7),d0/a0
L187
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1fSGIS:0",CODE


;void APIENTRY glMultiTexCoord1fSGIS(GLenum target, GLfloat s)
	XDEF	_glMultiTexCoord1fSGIS
_glMultiTexCoord1fSGIS
	move.l	4(a7),d0
	fmove.s	$8(a7),fp0
L188
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1fvSGIS:0",CODE


;void APIENTRY glMultiTexCoord1fvSGIS(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord1fvSGIS
_glMultiTexCoord1fvSGIS
	movem.l	4(a7),d0/a0
L189
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1iSGIS:0",CODE


;void APIENTRY glMultiTexCoord1iSGIS(GLenum target, GLint s)
	XDEF	_glMultiTexCoord1iSGIS
_glMultiTexCoord1iSGIS
	movem.l	4(a7),d0/d1
L190
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1ivSGIS:0",CODE


;void APIENTRY glMultiTexCoord1ivSGIS(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord1ivSGIS
_glMultiTexCoord1ivSGIS
	movem.l	4(a7),d1/a0
L191
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1sSGIS:0",CODE


;void APIENTRY glMultiTexCoord1sSGIS(GLenum target, GLshort s)
	XDEF	_glMultiTexCoord1sSGIS
_glMultiTexCoord1sSGIS
	move.w	$8(a7),d0
	move.l	4(a7),d1
L192
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1svSGIS:0",CODE


;void APIENTRY glMultiTexCoord1svSGIS(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord1svSGIS
_glMultiTexCoord1svSGIS
	movem.l	4(a7),d1/a0
L193
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2dSGIS:0",CODE


;void APIENTRY glMultiTexCoord2dSGIS(GLenum target, GLdouble s, GLdou
	XDEF	_glMultiTexCoord2dSGIS
_glMultiTexCoord2dSGIS
	move.l	4(a7),d0
	fmove.d	$10(a7),fp0
	fmove.d	$8(a7),fp1
L194
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2dvSGIS:0",CODE


;void APIENTRY glMultiTexCoord2dvSGIS(GLenum target, const GLdouble *
	XDEF	_glMultiTexCoord2dvSGIS
_glMultiTexCoord2dvSGIS
	movem.l	4(a7),d0/a1
L195
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.d	$8(a1),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a1),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2fSGIS:0",CODE


;void APIENTRY glMultiTexCoord2fSGIS(GLenum target, GLfloat s, GLfloa
	XDEF	_glMultiTexCoord2fSGIS
_glMultiTexCoord2fSGIS
	move.l	4(a7),d0
	fmove.s	$8(a7),fp0
	fmove.s	$C(a7),fp1
L196
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2fvSGIS:0",CODE


;void APIENTRY glMultiTexCoord2fvSGIS(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord2fvSGIS
_glMultiTexCoord2fvSGIS
	movem.l	4(a7),d0/a1
L197
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	move.l	4(a1),-(a7)
	move.l	(a1),-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2iSGIS:0",CODE


;void APIENTRY glMultiTexCoord2iSGIS(GLenum target, GLint s, GLint t)
	XDEF	_glMultiTexCoord2iSGIS
_glMultiTexCoord2iSGIS
	move.l	d2,-(a7)
	movem.l	$8(a7),d0-d2
L198
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	move.l	(a7)+,d2
	rts

	SECTION "_glMultiTexCoord2ivSGIS:0",CODE


;void APIENTRY glMultiTexCoord2ivSGIS(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord2ivSGIS
_glMultiTexCoord2ivSGIS
	movem.l	4(a7),d1/a1
L199
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.l	4(a1),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a1),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2sSGIS:0",CODE


;void APIENTRY glMultiTexCoord2sSGIS(GLenum target, GLshort s, GLshor
	XDEF	_glMultiTexCoord2sSGIS
_glMultiTexCoord2sSGIS
	move.l	d2,-(a7)
	move.w	$E(a7),d0
	move.l	$8(a7),d1
	move.w	$C(a7),d2
L200
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	move.l	(a7)+,d2
	rts

	SECTION "_glMultiTexCoord2svSGIS:0",CODE


;void APIENTRY glMultiTexCoord2svSGIS(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord2svSGIS
_glMultiTexCoord2svSGIS
	movem.l	4(a7),d1/a1
L201
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	move.w	2(a1),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a1),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3dSGIS:0",CODE


;void APIENTRY glMultiTexCoord3dSGIS(GLenum target, GLdouble s, GLdou
	XDEF	_glMultiTexCoord3dSGIS
_glMultiTexCoord3dSGIS
	fmovem.x fp2,-(a7)
	move.l	$10(a7),d0
	fmove.d	$24(a7),fp0
	fmove.d	$14(a7),fp1
	fmove.d	$1C(a7),fp2
L202
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	fmove.s	fp0,-(a7)
	fmove.x	fp2,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2
	rts

	SECTION "_glMultiTexCoord3dvSGIS:0",CODE


;void APIENTRY glMultiTexCoord3dvSGIS(GLenum target, const GLdouble *
	XDEF	_glMultiTexCoord3dvSGIS
_glMultiTexCoord3dvSGIS
	movem.l	4(a7),d0/a0
L203
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	fmove.d	$10(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3fSGIS:0",CODE


;void APIENTRY glMultiTexCoord3fSGIS(GLenum target, GLfloat s, GLfloa
	XDEF	_glMultiTexCoord3fSGIS
_glMultiTexCoord3fSGIS
	fmovem.x fp2,-(a7)
	move.l	$10(a7),d0
	fmove.s	$14(a7),fp0
	fmove.s	$18(a7),fp1
	fmove.s	$1C(a7),fp2
L204
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2
	rts

	SECTION "_glMultiTexCoord3fvSGIS:0",CODE


;void APIENTRY glMultiTexCoord3fvSGIS(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord3fvSGIS
_glMultiTexCoord3fvSGIS
	movem.l	4(a7),d0/a0
L205
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	move.l	$8(a0),-(a7)
	move.l	4(a0),-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3iSGIS:0",CODE


;void APIENTRY glMultiTexCoord3iSGIS(GLenum target, GLint s, GLint t,
	XDEF	_glMultiTexCoord3iSGIS
_glMultiTexCoord3iSGIS
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d3
L206
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	fmove.l	d3,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2/d3
	rts

	SECTION "_glMultiTexCoord3ivSGIS:0",CODE


;void APIENTRY glMultiTexCoord3ivSGIS(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord3ivSGIS
_glMultiTexCoord3ivSGIS
	movem.l	4(a7),d1/a0
L207
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	fmove.l	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	4(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3sSGIS:0",CODE


;void APIENTRY glMultiTexCoord3sSGIS(GLenum target, GLshort s, GLshor
	XDEF	_glMultiTexCoord3sSGIS
_glMultiTexCoord3sSGIS
	movem.l	d2/d3,-(a7)
	move.w	$14(a7),d0
	move.l	$C(a7),d1
	move.w	$10(a7),d2
	move.w	$12(a7),d3
L208
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d3,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2/d3
	rts

	SECTION "_glMultiTexCoord3svSGIS:0",CODE


;void APIENTRY glMultiTexCoord3svSGIS(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord3svSGIS
_glMultiTexCoord3svSGIS
	movem.l	4(a7),d1/a0
L209
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	move.w	4(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	2(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4dSGIS:0",CODE


;void APIENTRY glMultiTexCoord4dSGIS(GLenum target, GLdouble s, GLdou
	XDEF	_glMultiTexCoord4dSGIS
_glMultiTexCoord4dSGIS
	fmovem.x fp2/fp3,-(a7)
	move.l	$1C(a7),d0
	fmove.d	$38(a7),fp0
	fmove.d	$20(a7),fp1
	fmove.d	$28(a7),fp2
	fmove.d	$30(a7),fp3
L210
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	fmove.s	fp0,-(a7)
	fmove.x	fp3,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp2,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2/fp3
	rts

	SECTION "_glMultiTexCoord4dvSGIS:0",CODE


;void APIENTRY glMultiTexCoord4dvSGIS(GLenum target, const GLdouble *
	XDEF	_glMultiTexCoord4dvSGIS
_glMultiTexCoord4dvSGIS
	movem.l	4(a7),d0/a0
L211
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	fmove.d	$18(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$10(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4fSGIS:0",CODE


;void APIENTRY glMultiTexCoord4fSGIS(GLenum target, GLfloat s, GLfloa
	XDEF	_glMultiTexCoord4fSGIS
_glMultiTexCoord4fSGIS
	fmovem.x fp2/fp3,-(a7)
	move.l	$1C(a7),d0
	fmove.s	$20(a7),fp0
	fmove.s	$24(a7),fp1
	fmove.s	$28(a7),fp2
	fmove.s	$2C(a7),fp3
L212
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	fmove.s	fp3,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2/fp3
	rts

	SECTION "_glMultiTexCoord4fvSGIS:0",CODE


;void APIENTRY glMultiTexCoord4fvSGIS(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord4fvSGIS
_glMultiTexCoord4fvSGIS
	movem.l	4(a7),d0/a0
L213
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	move.l	$C(a0),-(a7)
	move.l	$8(a0),-(a7)
	move.l	4(a0),-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4iSGIS:0",CODE


;void APIENTRY glMultiTexCoord4iSGIS(GLenum target, GLint s, GLint t,
	XDEF	_glMultiTexCoord4iSGIS
_glMultiTexCoord4iSGIS
	movem.l	d2-d4,-(a7)
	movem.l	$10(a7),d0-d4
L214
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	fmove.l	d4,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d3,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2-d4
	rts

	SECTION "_glMultiTexCoord4ivSGIS:0",CODE


;void APIENTRY glMultiTexCoord4ivSGIS(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord4ivSGIS
_glMultiTexCoord4ivSGIS
	movem.l	4(a7),d1/a0
L215
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	fmove.l	$C(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	4(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4sSGIS:0",CODE


;void APIENTRY glMultiTexCoord4sSGIS(GLenum target, GLshort s, GLshor
	XDEF	_glMultiTexCoord4sSGIS
_glMultiTexCoord4sSGIS
	movem.l	d2-d4,-(a7)
	move.w	$1A(a7),d0
	move.l	$10(a7),d1
	move.w	$14(a7),d2
	move.w	$16(a7),d3
	move.w	$18(a7),d4
L216
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d4,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d3,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2-d4
	rts

	SECTION "_glMultiTexCoord4svSGIS:0",CODE


;void APIENTRY glMultiTexCoord4svSGIS(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord4svSGIS
_glMultiTexCoord4svSGIS
	movem.l	4(a7),d1/a0
L217
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	move.w	6(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	4(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	2(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoordPointerSGIS:0",CODE


;void APIENTRY glMultiTexCoordPointerSGIS(GLenum target, GLint size, 
	XDEF	_glMultiTexCoordPointerSGIS
_glMultiTexCoordPointerSGIS
	movem.l	d2-d4,-(a7)
	movem.l	$10(a7),d0-d3/a0
L220
;   
	tst.l	_CC(a6)
	bne.b	L224
L221
;   
	move.l	#L218,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L223
L222
;   
	move.l	#L219,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L223
	movem.l	(a7)+,d2-d4
	rts
L224
;   (*CC->API.MultiTexCoordPointer)(CC, target, size, type, stride
	move.l	a0,-(a7)
	move.l	d3,-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E8(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2-d4
	rts

L218
	dc.b	'MESA_DEBUG',0
L219
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glSelectTextureSGIS:0",CODE


;void APIENTRY glSelectTextureSGIS(GLenum target)
	XDEF	_glSelectTextureSGIS
_glSelectTextureSGIS
	move.l	4(a7),d0
L227
;   
	tst.l	_CC(a6)
	bne.b	L231
L228
;   
	move.l	#L225,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L230
L229
;   
	move.l	#L226,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L230
	rts
L231
;   (*CC->API.SelectTextureSGIS)(CC, target);
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2F0(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L225
	dc.b	'MESA_DEBUG',0
L226
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glSelectTextureCoordSetSGIS:0",CODE


;void APIENTRY glSelectTextureCoordSetSGIS(GLenum target)
	XDEF	_glSelectTextureCoordSetSGIS
_glSelectTextureCoordSetSGIS
	move.l	4(a7),d0
L234
;   
	tst.l	_CC(a6)
	bne.b	L238
L235
;   
	move.l	#L232,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L237
L236
;   
	move.l	#L233,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L237
	rts
L238
;   (*CC->API.SelectTextureCoordSet)(CC, target);
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2F8(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L232
	dc.b	'MESA_DEBUG',0
L233
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glMultiTexCoord1dEXT:0",CODE


;void APIENTRY glMultiTexCoord1dEXT(GLenum target, GLdouble s)
	XDEF	_glMultiTexCoord1dEXT
_glMultiTexCoord1dEXT
	move.l	4(a7),d0
	fmove.d	$8(a7),fp0
L239
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1dvEXT:0",CODE


;void APIENTRY glMultiTexCoord1dvEXT(GLenum target, const GLdouble *v)
	XDEF	_glMultiTexCoord1dvEXT
_glMultiTexCoord1dvEXT
	movem.l	4(a7),d0/a0
L240
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1fEXT:0",CODE


;void APIENTRY glMultiTexCoord1fEXT(GLenum target, GLfloat s)
	XDEF	_glMultiTexCoord1fEXT
_glMultiTexCoord1fEXT
	move.l	4(a7),d0
	fmove.s	$8(a7),fp0
L241
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1fvEXT:0",CODE


;void APIENTRY glMultiTexCoord1fvEXT(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord1fvEXT
_glMultiTexCoord1fvEXT
	movem.l	4(a7),d0/a0
L242
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1iEXT:0",CODE


;void APIENTRY glMultiTexCoord1iEXT(GLenum target, GLint s)
	XDEF	_glMultiTexCoord1iEXT
_glMultiTexCoord1iEXT
	movem.l	4(a7),d0/d1
L243
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1ivEXT:0",CODE


;void APIENTRY glMultiTexCoord1ivEXT(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord1ivEXT
_glMultiTexCoord1ivEXT
	movem.l	4(a7),d1/a0
L244
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1sEXT:0",CODE


;void APIENTRY glMultiTexCoord1sEXT(GLenum target, GLshort s)
	XDEF	_glMultiTexCoord1sEXT
_glMultiTexCoord1sEXT
	move.w	$8(a7),d0
	move.l	4(a7),d1
L245
;   (*CC->API.MultiTexCoord4f)( CC, target, s, 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord1svEXT:0",CODE


;void APIENTRY glMultiTexCoord1svEXT(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord1svEXT
_glMultiTexCoord1svEXT
	movem.l	4(a7),d1/a0
L246
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], 0.0, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	clr.l	-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2dEXT:0",CODE


;void APIENTRY glMultiTexCoord2dEXT(GLenum target, GLdouble s, GLdoub
	XDEF	_glMultiTexCoord2dEXT
_glMultiTexCoord2dEXT
	move.l	4(a7),d0
	fmove.d	$10(a7),fp0
	fmove.d	$8(a7),fp1
L247
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2dvEXT:0",CODE


;void APIENTRY glMultiTexCoord2dvEXT(GLenum target, const GLdouble *v)
	XDEF	_glMultiTexCoord2dvEXT
_glMultiTexCoord2dvEXT
	movem.l	4(a7),d0/a1
L248
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.d	$8(a1),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a1),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2fEXT:0",CODE


;void APIENTRY glMultiTexCoord2fEXT(GLenum target, GLfloat s, GLfloat
	XDEF	_glMultiTexCoord2fEXT
_glMultiTexCoord2fEXT
	move.l	4(a7),d0
	fmove.s	$8(a7),fp0
	fmove.s	$C(a7),fp1
L249
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2fvEXT:0",CODE


;void APIENTRY glMultiTexCoord2fvEXT(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord2fvEXT
_glMultiTexCoord2fvEXT
	movem.l	4(a7),d0/a1
L250
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	move.l	4(a1),-(a7)
	move.l	(a1),-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2iEXT:0",CODE


;void APIENTRY glMultiTexCoord2iEXT(GLenum target, GLint s, GLint t)
	XDEF	_glMultiTexCoord2iEXT
_glMultiTexCoord2iEXT
	move.l	d2,-(a7)
	movem.l	$8(a7),d0-d2
L251
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	move.l	(a7)+,d2
	rts

	SECTION "_glMultiTexCoord2ivEXT:0",CODE


;void APIENTRY glMultiTexCoord2ivEXT(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord2ivEXT
_glMultiTexCoord2ivEXT
	movem.l	4(a7),d1/a1
L252
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	fmove.l	4(a1),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a1),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord2sEXT:0",CODE


;void APIENTRY glMultiTexCoord2sEXT(GLenum target, GLshort s, GLshort
	XDEF	_glMultiTexCoord2sEXT
_glMultiTexCoord2sEXT
	move.l	d2,-(a7)
	move.w	$E(a7),d0
	move.l	$8(a7),d1
	move.w	$C(a7),d2
L253
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	move.l	(a7)+,d2
	rts

	SECTION "_glMultiTexCoord2svEXT:0",CODE


;void APIENTRY glMultiTexCoord2svEXT(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord2svEXT
_glMultiTexCoord2svEXT
	movem.l	4(a7),d1/a1
L254
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], 0.0, 1.0 );
	move.l	#$3F800000,-(a7)
	clr.l	-(a7)
	move.w	2(a1),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a1),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3dEXT:0",CODE


;void APIENTRY glMultiTexCoord3dEXT(GLenum target, GLdouble s, GLdoub
	XDEF	_glMultiTexCoord3dEXT
_glMultiTexCoord3dEXT
	fmovem.x fp2,-(a7)
	move.l	$10(a7),d0
	fmove.d	$24(a7),fp0
	fmove.d	$14(a7),fp1
	fmove.d	$1C(a7),fp2
L255
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	fmove.s	fp0,-(a7)
	fmove.x	fp2,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2
	rts

	SECTION "_glMultiTexCoord3dvEXT:0",CODE


;void APIENTRY glMultiTexCoord3dvEXT(GLenum target, const GLdouble *v)
	XDEF	_glMultiTexCoord3dvEXT
_glMultiTexCoord3dvEXT
	movem.l	4(a7),d0/a0
L256
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	fmove.d	$10(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3fEXT:0",CODE


;void APIENTRY glMultiTexCoord3fEXT(GLenum target, GLfloat s, GLfloat
	XDEF	_glMultiTexCoord3fEXT
_glMultiTexCoord3fEXT
	fmovem.x fp2,-(a7)
	move.l	$10(a7),d0
	fmove.s	$14(a7),fp0
	fmove.s	$18(a7),fp1
	fmove.s	$1C(a7),fp2
L257
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2
	rts

	SECTION "_glMultiTexCoord3fvEXT:0",CODE


;void APIENTRY glMultiTexCoord3fvEXT(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord3fvEXT
_glMultiTexCoord3fvEXT
	movem.l	4(a7),d0/a0
L258
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	move.l	$8(a0),-(a7)
	move.l	4(a0),-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3iEXT:0",CODE


;void APIENTRY glMultiTexCoord3iEXT(GLenum target, GLint s, GLint t, 
	XDEF	_glMultiTexCoord3iEXT
_glMultiTexCoord3iEXT
	movem.l	d2/d3,-(a7)
	movem.l	$C(a7),d0-d3
L259
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	fmove.l	d3,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2/d3
	rts

	SECTION "_glMultiTexCoord3ivEXT:0",CODE


;void APIENTRY glMultiTexCoord3ivEXT(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord3ivEXT
_glMultiTexCoord3ivEXT
	movem.l	4(a7),d1/a0
L260
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	fmove.l	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	4(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord3sEXT:0",CODE


;void APIENTRY glMultiTexCoord3sEXT(GLenum target, GLshort s, GLshort
	XDEF	_glMultiTexCoord3sEXT
_glMultiTexCoord3sEXT
	movem.l	d2/d3,-(a7)
	move.w	$14(a7),d0
	move.l	$C(a7),d1
	move.w	$10(a7),d2
	move.w	$12(a7),d3
L261
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, 1.0 );
	move.l	#$3F800000,-(a7)
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d3,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2/d3
	rts

	SECTION "_glMultiTexCoord3svEXT:0",CODE


;void APIENTRY glMultiTexCoord3svEXT(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord3svEXT
_glMultiTexCoord3svEXT
	movem.l	4(a7),d1/a0
L262
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], 1.0 )
	move.l	#$3F800000,-(a7)
	move.w	4(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	2(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4dEXT:0",CODE


;void APIENTRY glMultiTexCoord4dEXT(GLenum target, GLdouble s, GLdoub
	XDEF	_glMultiTexCoord4dEXT
_glMultiTexCoord4dEXT
	fmovem.x fp2/fp3,-(a7)
	move.l	$1C(a7),d0
	fmove.d	$38(a7),fp0
	fmove.d	$20(a7),fp1
	fmove.d	$28(a7),fp2
	fmove.d	$30(a7),fp3
L263
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	fmove.s	fp0,-(a7)
	fmove.x	fp3,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp2,fp0
	fmove.s	fp0,-(a7)
	fmove.x	fp1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2/fp3
	rts

	SECTION "_glMultiTexCoord4dvEXT:0",CODE


;void APIENTRY glMultiTexCoord4dvEXT(GLenum target, const GLdouble *v)
	XDEF	_glMultiTexCoord4dvEXT
_glMultiTexCoord4dvEXT
	movem.l	4(a7),d0/a0
L264
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	fmove.d	$18(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$10(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.d	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4fEXT:0",CODE


;void APIENTRY glMultiTexCoord4fEXT(GLenum target, GLfloat s, GLfloat
	XDEF	_glMultiTexCoord4fEXT
_glMultiTexCoord4fEXT
	fmovem.x fp2/fp3,-(a7)
	move.l	$1C(a7),d0
	fmove.s	$20(a7),fp0
	fmove.s	$24(a7),fp1
	fmove.s	$28(a7),fp2
	fmove.s	$2C(a7),fp3
L265
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	fmove.s	fp3,-(a7)
	fmove.s	fp2,-(a7)
	fmove.s	fp1,-(a7)
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	fmovem.x (a7)+,fp2/fp3
	rts

	SECTION "_glMultiTexCoord4fvEXT:0",CODE


;void APIENTRY glMultiTexCoord4fvEXT(GLenum target, const GLfloat *v)
	XDEF	_glMultiTexCoord4fvEXT
_glMultiTexCoord4fvEXT
	movem.l	4(a7),d0/a0
L266
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	move.l	$C(a0),-(a7)
	move.l	$8(a0),-(a7)
	move.l	4(a0),-(a7)
	fmove.s	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4iEXT:0",CODE


;void APIENTRY glMultiTexCoord4iEXT(GLenum target, GLint s, GLint t, 
	XDEF	_glMultiTexCoord4iEXT
_glMultiTexCoord4iEXT
	movem.l	d2-d4,-(a7)
	movem.l	$10(a7),d0-d4
L267
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	fmove.l	d4,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d3,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d2,fp0
	fmove.s	fp0,-(a7)
	fmove.l	d1,fp0
	fmove.s	fp0,-(a7)
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2-d4
	rts

	SECTION "_glMultiTexCoord4ivEXT:0",CODE


;void APIENTRY glMultiTexCoord4ivEXT(GLenum target, const GLint *v)
	XDEF	_glMultiTexCoord4ivEXT
_glMultiTexCoord4ivEXT
	movem.l	4(a7),d1/a0
L268
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	fmove.l	$C(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	$8(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	4(a0),fp0
	fmove.s	fp0,-(a7)
	fmove.l	(a0),fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glMultiTexCoord4sEXT:0",CODE


;void APIENTRY glMultiTexCoord4sEXT(GLenum target, GLshort s, GLshort
	XDEF	_glMultiTexCoord4sEXT
_glMultiTexCoord4sEXT
	movem.l	d2-d4,-(a7)
	move.w	$1A(a7),d0
	move.l	$10(a7),d1
	move.w	$14(a7),d2
	move.w	$16(a7),d3
	move.w	$18(a7),d4
L269
;   (*CC->API.MultiTexCoord4f)( CC, target, s, t, r, q );
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d4,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d3,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	d2,d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	movem.l	(a7)+,d2-d4
	rts

	SECTION "_glMultiTexCoord4svEXT:0",CODE


;void APIENTRY glMultiTexCoord4svEXT(GLenum target, const GLshort *v)
	XDEF	_glMultiTexCoord4svEXT
_glMultiTexCoord4svEXT
	movem.l	4(a7),d1/a0
L270
;   (*CC->API.MultiTexCoord4f)( CC, target, v[0], v[1], v[2], v[3]
	move.w	6(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	4(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	2(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.w	(a0),d0
	ext.l	d0
	fmove.l	d0,fp0
	fmove.s	fp0,-(a7)
	move.l	d1,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2E4(a1),a0
	jsr	(a0)
	add.w	#$18,a7
	rts

	SECTION "_glInterleavedTextureCoordSetsEXT:0",CODE


;void APIENTRY glInterleavedTextureCoordSetsEXT( GLint factor )
	XDEF	_glInterleavedTextureCoordSetsEXT
_glInterleavedTextureCoordSetsEXT
	move.l	4(a7),d0
L273
;   
	tst.l	_CC(a6)
	bne.b	L277
L274
;   
	move.l	#L271,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L276
L275
;   
	move.l	#L272,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L276
	rts
L277
;   (*CC->API.InterleavedTextureCoordSets)( CC, factor );
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2EC(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L271
	dc.b	'MESA_DEBUG',0
L272
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glSelectTextureTransformEXT:0",CODE


;void APIENTRY glSelectTextureTransformEXT( GLenum target )
	XDEF	_glSelectTextureTransformEXT
_glSelectTextureTransformEXT
	move.l	4(a7),d0
L280
;   
	tst.l	_CC(a6)
	bne.b	L284
L281
;   
	move.l	#L278,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L283
L282
;   
	move.l	#L279,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L283
	rts
L284
;   (*CC->API.SelectTextureTransform)( CC, target );
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2FC(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L278
	dc.b	'MESA_DEBUG',0
L279
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glSelectTextureEXT:0",CODE


;void APIENTRY glSelectTextureEXT( GLenum target )
	XDEF	_glSelectTextureEXT
_glSelectTextureEXT
	move.l	4(a7),d0
L287
;   
	tst.l	_CC(a6)
	bne.b	L291
L288
;   
	move.l	#L285,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L290
L289
;   
	move.l	#L286,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L290
	rts
L291
;   (*CC->API.SelectTexture)( CC, target );
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2F4(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L285
	dc.b	'MESA_DEBUG',0
L286
	dc.b	'Mesa user error: no rendering context.',$A,0

	SECTION "_glSelectTextureCoordSetEXT:0",CODE


;void APIENTRY glSelectTextureCoordSetEXT( GLenum target )
	XDEF	_glSelectTextureCoordSetEXT
_glSelectTextureCoordSetEXT
	move.l	4(a7),d0
L294
;   
	tst.l	_CC(a6)
	bne.b	L298
L295
;   
	move.l	#L292,-(a7)
	jsr	_getenv
	addq.w	#4,a7
	tst.l	d0
	beq.b	L297
L296
;   
	move.l	#L293,-(a7)
	pea	_std__err(a6)
	jsr	_fprintf
	addq.w	#$8,a7
L297
	rts
L298
;   (*CC->API.SelectTextureCoordSet)( CC, target );
	move.l	d0,-(a7)
	move.l	_CC(a6),-(a7)
	move.l	_CC(a6),a1
	move.l	$2F8(a1),a0
	jsr	(a0)
	addq.w	#$8,a7
	rts

L292
	dc.b	'MESA_DEBUG',0
L293
	dc.b	'Mesa user error: no rendering context.',$A,0

	END
